
#include <pspkernel.h>
#include <pspiofilemgr.h>
#include <pspctrl.h>
#include <stdio.h>
#include <string.h>

PSP_MODULE_INFO("Memory Dump", 0x1000, 1, 0);
PSP_MAIN_THREAD_ATTR(0);

#define MAX_THREAD	64

#define USER_MEM (0x08800000)

/***************************************

t@Cɕۑ

****************************************/
void dump(void){
	static int count = 0;
	char file[20];
	
	sprintf(file, "ms0:/mem%02d.bin", count);
	
	int fd = sceIoOpen(file, PSP_O_CREAT|PSP_O_WRONLY|PSP_O_TRUNC, 0777);
	if(fd < 0) return;
	
	sceIoWrite(fd, (char*)USER_MEM, 24*1024*1024);
	sceIoClose(fd);

	count++;
}

/***************************************

CXbh

****************************************/
int mainThread (SceSize args, void *argp){
	unsigned int paddata_old = 0;
	int x, y, thread_count_start, thread_count_now;
	SceUID thread_buf_start[MAX_THREAD], thread_buf_now[MAX_THREAD], myThread = sceKernelGetThreadId();
	SceCtrlData paddata;
	
	sceKernelDelayThread(10000);
	sceKernelGetThreadmanIdList(SCE_KERNEL_TMID_Thread, thread_buf_start, MAX_THREAD, &thread_count_start);
	
	while(1){
		sceCtrlPeekBufferPositive(&paddata, 1);
		
		if(paddata.Buttons != paddata_old){
			//_v
			if((paddata.Buttons & (PSP_CTRL_RTRIGGER | 0x00100000)) == (PSP_CTRL_RTRIGGER | 0x00100000)){

				// IdList Now
				sceKernelGetThreadmanIdList(SCE_KERNEL_TMID_Thread, thread_buf_now, MAX_THREAD, &thread_count_now);

				for(x = 0; x < thread_count_now; x++){
					// thread id match 0 or 1
					unsigned char match = 0;
					SceUID tmp_thid = thread_buf_now[x];
					for(y = 0; y < thread_count_start; y++){
						if((tmp_thid == thread_buf_start[y]) || (tmp_thid == myThread)){
							match = 1;
							y = thread_count_start;
						}
					}
					if(thread_count_start == 0) match = 1;
					if(match == 0){
						sceKernelSuspendThread(tmp_thid);
					}

				}
					
				dump();
				
				// XbhĊJ
				for(x = 0; x < thread_count_now; x++){
					// thread id match 0 or 1
					unsigned char match = 0;
					SceUID tmp_thid = thread_buf_now[x];
					for(y = 0; y < thread_count_start; y++){
						if((tmp_thid == thread_buf_start[y]) || (tmp_thid == myThread)){
							match = 1;
							y = thread_count_start;
						}
					}
					if(thread_count_start == 0) match = 1;
					if(match == 0){
						sceKernelResumeThread(tmp_thid);
					}
				}
			}
		}
		paddata_old = paddata.Buttons;
		sceKernelDelayThread(10000);
	}
	return 0;
}

/***************************************

W[X^[g

****************************************/
int module_start (SceSize args, void *argp)
{
	SceUID thid;

	thid = sceKernelCreateThread("memdump", mainThread, 0x18, 0x1000, 0, NULL);
	if (thid >= 0) sceKernelStartThread(thid, args, argp);

	return 0;
}

/***************************************

W[Xgbv

****************************************/
int module_stop (void)
{
	return 0;
}
